import { renderless, api } from '@opentinyvue/vue-renderless/cascader-view/vue';
import { defineComponent, $prefix, setup, $props } from '@opentinyvue/vue-common';
import { IconChevronRight, IconChevronUp, IconSearch, IconOperationfaild, IconChevronLeft } from '@opentinyvue/vue-icon';
import Button from '@opentinyvue/vue-button';
import ActionSheet from '@opentinyvue/vue-action-sheet';
import Exception from '@opentinyvue/vue-exception';
import Checkbox from '@opentinyvue/vue-checkbox';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "flex items-start leading-5.5 cursor-pointer select-none",
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, [_vm.option ? _c("span", {
    staticClass: "w-11 h-11 flex-none flex items-center justify-center relative",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.$emit("check", _vm.option);
      }
    }
  }, [_c("div", {
    staticClass: "absolute left-0 right-0 top-0 bottom-0 z-20"
  }), _c("tiny-checkbox", {
    attrs: {
      "custom-class": "flex h-full w-full items-center justify-center",
      "model-value": !_vm.option.indeterminate && _vm.option.checked,
      "indeterminate": _vm.option.indeterminate,
      "disabled": _vm.data.disabled
    }
  })], 1) : _vm._e(), _c("div", {
    class: ["flex-auto flex w-full text-sm py-3", {
      "truncate": _vm.ellipsis
    }],
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.$emit("expand", _vm.option);
      }
    }
  }, [_vm._t("default", function() {
    return [_c("div", {
      class: ["flex-auto", {
        "truncate": _vm.ellipsis
      }]
    }, [_c("div", {
      staticClass: "flex"
    }, [_c("div", {
      class: [{
        "min-w-[theme(spacing.14)]": !_vm.textField3
      }, {
        "truncate": _vm.ellipsis
      }]
    }, [_vm._v(" " + _vm._s(_vm.data[_vm.textField]) + " ")]), _vm.textField2 ? _c("div", {
      class: ["ml-5 text-color-text-placeholder", {
        "truncate": _vm.ellipsis
      }]
    }, [_vm._v(" " + _vm._s(_vm.data[_vm.textField2]) + " ")]) : _vm._e()]), _vm.textField3 ? _c("div", {
      class: ["text-color-text-placeholder", {
        "truncate": _vm.ellipsis
      }]
    }, [_vm._v(" " + _vm._s(_vm.data[_vm.textField3]) + " ")]) : _vm._e()]), !_vm.loading && !_vm.option.isLeaf ? _c("div", {
      staticClass: "flex flex-none w-8 items-center justify-end ml-2"
    }, [_c("IconChevronRight", {
      attrs: {
        "custom-class": "w-4 h-4 fill-current"
      }
    })], 1) : _vm._e(), _vm.option.loading ? _c("div", {
      staticClass: "flex flex-none w-5 items-center justify-center ml-2"
    }, [_c("svg", {
      staticClass: "animate-[spin_1.5s_linear_infinite] fill-current",
      attrs: {
        "viewBox": "25 25 50 50"
      }
    }, [_c("circle", {
      staticClass: "stroke-color-brand tiny-loading-path",
      attrs: {
        "cx": "50",
        "cy": "50",
        "r": "24",
        "fill": "none"
      }
    })])]) : _vm._e()];
  })], 2)]);
};
var staticRenderFns$1 = [];
var __vue2_script$1 = {
  emits: ["click"],
  components: {
    TinyCheckbox: Checkbox,
    IconChevronRight: IconChevronRight()
  },
  props: ["selected", "ellipsis", "option", "textField", "textField2", "textField3", "loading"],
  computed: {
    data: function data() {
      return this.option.data || this.option;
    }
  }
};
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var Option = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var $constants = {
  defaultNodeConfig: {
    lazy: false,
    load: null,
    isLeaf: "leaf",
    afterLoad: null,
    currentNodeKey: null,
    checkStrictly: false,
    checkDescendants: null,
    defaultCheckedKeys: null,
    defaultExpandedKeys: null,
    autoExpandParent: null,
    defaultExpandAll: null,
    filterNodeMethod: null
  }
};
var __vue2_script = defineComponent({
  name: $prefix + "CascaderView",
  emits: ["click", "update:text", "update:visible", "close", "update:modelValue", "search-click", "confirm"],
  components: {
    TinyOption: Option,
    TinyActionSheet: ActionSheet,
    TinyButton: Button,
    TinyException: Exception,
    IconChevronRight: IconChevronRight(),
    IconChevronUp: IconChevronUp(),
    IconSearch: IconSearch(),
    IconOperationfaild: IconOperationfaild(),
    IconChevronLeft: IconChevronLeft()
  },
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    data: {
      type: Array,
      default: function _default2() {
        return [];
      }
    },
    modelValue: [Number, String, Array],
    visible: {
      type: Boolean,
      default: false
    },
    valueField: {
      type: String,
      default: "id"
    },
    textField: {
      type: String,
      default: "label"
    },
    textField2: {
      type: String,
      default: ""
    },
    textField3: {
      type: String,
      default: ""
    },
    title: String,
    textSplit: {
      type: String,
      default: "; "
    },
    showHeader: {
      type: Boolean,
      default: true
    },
    customClass: [String, Object, Array],
    mask: {
      type: Boolean,
      default: true
    },
    ellipsis: {
      type: Boolean,
      default: false
    },
    searchConfig: {
      type: Object,
      default: function _default3() {
        return {
          options: [],
          searchMethod: null,
          openSearchSlot: false
        };
      }
    },
    childrenField: {
      type: String,
      default: "children"
    },
    nodeConfig: {
      type: Object,
      default: function _default4() {
        return $constants.defaultNodeConfig;
      }
    },
    lockScroll: {
      type: Boolean,
      default: true
    },
    emitPath: {
      type: Boolean,
      default: true
    }
  }),
  setup: function setup$1(props, context) {
    return setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    attrs: {
      "data-tag": "tiny-cascader-view"
    }
  }, [_c("tiny-action-sheet", {
    ref: "actionSheet",
    attrs: {
      "title": _vm.title,
      "lock-scroll": _vm.lockScroll,
      "mask": _vm.mask,
      "show-header": _vm.showHeader,
      "custom-class": _vm.m("h-full max-h-full rounded-none text-color-text-primary pb-0", _vm.customClass),
      "visible": _vm.visible
    },
    on: {
      "update:visible": function updateVisible($event) {
        return _vm.$emit("update:visible", $event);
      }
    },
    scopedSlots: _vm._u([{
      key: "header-left",
      fn: function fn() {
        return [_c("IconChevronLeft", {
          staticClass: "h-5 w-5 fill-color-text-primary cursor-pointer",
          on: {
            "click": _vm.close
          }
        })];
      },
      proxy: true
    }, {
      key: "header-right",
      fn: function fn() {
        return [_c("div")];
      },
      proxy: true
    }, {
      key: "body-top",
      fn: function fn() {
        return [_c("div", {
          staticClass: "flex leading-6 pb-4 px-4 text-base items-center border-b-0.5 border-color-border-separator",
          attrs: {
            "data-tag": "search-header"
          }
        }, [_c("div", {
          staticClass: "flex-auto flex items-center h-8 py-1 px-3 bg-color-bg-4 rounded"
        }, [_c("IconSearch", {
          staticClass: "mr-1 fill-color-icon-disabled",
          attrs: {
            "custom-class": "h-4 w-4"
          }
        }), _c("input", {
          directives: [{
            name: "model",
            rawName: "v-model",
            value: _vm.state.search.input,
            expression: "state.search.input"
          }],
          staticClass: "h-5 flex-auto text-xs bg-transparent outline-0",
          attrs: {
            "placeholder": _vm.t("ui.select.pleaseSearch")
          },
          domProps: {
            "value": _vm.state.search.input
          },
          on: {
            "input": [function($event) {
              if ($event.target.composing) return;
              _vm.$set(_vm.state.search, "input", $event.target.value);
            }, _vm.inputKeyword],
            "keyup": function keyup($event) {
              if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) return null;
              return _vm.searchMethod.apply(null, arguments);
            }
          }
        })], 1), _c("div", {
          staticClass: "flex items-center pl-3 cursor-pointer"
        }, [_c("div", {
          on: {
            "click": _vm.searchMethod
          }
        }, [_vm._v(_vm._s(_vm.t("ui.select.search")))])])]), _c("div", {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: !_vm.state.search.show,
            expression: "!state.search.show"
          }],
          staticClass: "h-11 flex flex-none items-center border-b-0.5 border-color-border-separator overflow-auto whitespace-nowrap scrollbar-size-0",
          attrs: {
            "data-tag": "nav-box"
          }
        }, [_c("div", {
          staticClass: "px-4 flex"
        }, [_vm._l(_vm.state.computedNavList, function(option, index) {
          return _c("div", {
            key: index,
            staticClass: "flex-none flex items-center"
          }, [index !== 0 ? _c("span", {
            staticClass: "px-2 text-color-text-placeholder flex items-center"
          }, [_c("IconChevronRight", {
            attrs: {
              "custom-class": "w-4 h-4 fill-current"
            }
          })], 1) : _vm._e(), _c("span", {
            class: ["flex-none max-w-[theme(spacing.24)] truncate", {
              "text-color-brand": index === _vm.state.level
            }, _vm.disabledNavOption(index, option) ? "text-color-text-disabled" : "cursor-pointer"],
            on: {
              "click": function click($event) {
                return _vm.setLevel(index, option);
              }
            }
          }, [_vm._v(_vm._s(option.data[_vm.textField]))])]);
        }), _c("div", {
          staticClass: "flex-auto"
        })], 2)])];
      },
      proxy: true
    }, {
      key: "body-bottom",
      fn: function fn() {
        return [_c("div", {
          staticClass: "flex items-center py-4 px-3 border-t border-color-bg-4 shadow-sm",
          attrs: {
            "data-tag": "view-footer"
          }
        }, [_c("div", {
          staticClass: "cursor-pointer pr-2 leading-5.5",
          on: {
            "click": function click($event) {
              $event.stopPropagation();
              return _vm.toggleCheckList(true);
            }
          }
        }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.select.selectedNum", {
          num: _vm.state.computedCheckList.length
        })))]), _c("IconChevronUp", {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: _vm.state.computedCheckList.length,
            expression: "state.computedCheckList.length"
          }],
          staticClass: "flex-none w-4 h-4 ml-2 fill-current"
        })], 1), _c("div", {
          staticClass: "flex-auto"
        }), _c("tiny-button", {
          staticClass: "flex-none ml-3 w-28",
          attrs: {
            "tiny_mode": "mobile-first",
            "type": "primary",
            "size": "medium",
            "reset-time": 0
          },
          on: {
            "click": _vm.confirm
          }
        }, [_vm._v(" " + _vm._s(_vm.t("ui.button.confirm")) + " ")])], 1)];
      },
      proxy: true
    }])
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.state.search.show,
      expression: "!state.search.show"
    }],
    staticClass: "flex-auto",
    attrs: {
      "data-tag": "tabs"
    }
  }, _vm._l(_vm.state.options, function(currentList, index) {
    return _c("div", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: index === _vm.state.level,
        expression: "index === state.level"
      }],
      key: index,
      staticClass: "flex flex-col px-4 overflow-auto pt-2",
      attrs: {
        "data-tag": "tab-item"
      }
    }, _vm._l(currentList, function(item, OptIndex) {
      return _c("tiny-option", {
        key: item.data[_vm.valueField],
        attrs: {
          "ellipsis": _vm.ellipsis,
          "text-field": _vm.textField,
          "text-field2": _vm.textField2,
          "text-field3": _vm.textField3,
          "loading": _vm.state.loading,
          "option": item
        },
        on: {
          "check": function check($event) {
            return _vm.selectOption(item);
          },
          "expand": _vm.nodeExpand
        }
      }, [_vm._t("default", null, {
        "item": item,
        "index": OptIndex
      })], 2);
    }), 1);
  }), 0), _c("div", {
    class: [_vm.state.search.show ? "flex flex-col flex-auto" : "hidden"],
    attrs: {
      "data-tag": "search-box"
    }
  }, [_c("div", {
    staticClass: "flex-auto overflow-auto flex flex-col",
    attrs: {
      "data-tag": "search-body"
    }
  }, [_c("div", {
    class: ["flex flex-col px-4"]
  }, _vm._l(_vm.state.search.filterOptions, function(item, index) {
    return _c("tiny-option", {
      key: index,
      attrs: {
        "ellipsis": _vm.ellipsis,
        "text-field": _vm.textField,
        "text-field2": _vm.textField2,
        "text-field3": _vm.textField3,
        "option": item.node
      },
      on: {
        "check": function check($event) {
          return _vm.searchSelectHandler(item.node, index);
        }
      }
    }, [_vm.searchConfig.openSearchSlot ? _vm._t("search-item", null, {
      "item": item,
      "index": index
    }) : _vm._t("default", function() {
      return [_c("div", {
        class: ["flex-auto", {
          "truncate": _vm.ellipsis
        }]
      }, _vm._l(_vm.renderSearchOption(item.data[_vm.textField]), function(text, spanIndex) {
        return _c("span", {
          key: spanIndex
        }, [spanIndex ? _c("span", {
          staticClass: "text-color-brand"
        }, [_vm._v(_vm._s(_vm.state.search.input))]) : _vm._e(), _vm._v(_vm._s(text))]);
      }), 0)];
    }, {
      "item": item,
      "index": index
    })], 2);
  }), 1), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.search.loaded && !_vm.state.search.filterOptions.length,
      expression: "state.search.loaded && !state.search.filterOptions.length"
    }],
    staticClass: "w-full flex justify-center items-center text-center flex-auto"
  }, [_c("tiny-exception", {
    attrs: {
      "component-page": "",
      "type": "noresult",
      "tiny_mode": "mobile-first",
      "tiny_mode_root": ""
    }
  })], 1)])])]), _c("tiny-action-sheet", {
    attrs: {
      "data-tag": "selected-box",
      "custom-class": "h-3/4 text-color-text-primary",
      "title": _vm.t("ui.select.selected"),
      "show-footer": "",
      "lock-scroll": false,
      "menus": _vm.state.selected.options,
      "visible": _vm.state.selected.show
    },
    on: {
      "update:visible": function updateVisible($event) {
        _vm.state.selected.show = $event;
      }
    },
    scopedSlots: _vm._u([{
      key: "header-left",
      fn: function fn() {
        return [_c("div", {
          staticClass: "cursor-pointer text-color-brand",
          on: {
            "click": _vm.clean
          }
        }, [_vm._v(_vm._s(_vm.t("ui.datepicker.clear")))])];
      },
      proxy: true
    }, {
      key: "footer",
      fn: function fn() {
        return [_c("tiny-button", {
          attrs: {
            "tiny_mode": "mobile-first",
            "custom-class": "flex-1 w-full mx-4 sm:mx-0",
            "type": "primary",
            "size": "medium",
            "reset-time": 0
          },
          on: {
            "click": function click($event) {
              return _vm.toggleCheckList(false);
            }
          }
        }, [_vm._v(" " + _vm._s(_vm.t("ui.button.confirm")) + " ")])];
      },
      proxy: true
    }])
  }, [_c("div", {
    staticClass: "h-full overflow-auto scrollbar-size-0"
  }, _vm._l(_vm.state.computedSelectedList, function(item, index) {
    return _c("tiny-option", {
      key: index
    }, [_c("div", {
      staticClass: "flex flex-auto px-4 items-center overflow-hidden"
    }, [_c("div", {
      staticClass: "flex-auto truncate min-w-[theme(spacing.14)]"
    }, [_vm._v(" " + _vm._s(item.waitLoad ? item.data[_vm.valueField] : item.getPathText(_vm.textField, " / ")) + " ")]), _c("div", {
      staticClass: "flex-none pl-4 text-right"
    }, [_c("IconOperationfaild", {
      staticClass: "w-5 h-5 fill-color-text-placeholder",
      on: {
        "click": function click($event) {
          return _vm.removeOption(item);
        }
      }
    })], 1)])]);
  }), 1)])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var CascaderView = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.21.0";
CascaderView.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
CascaderView.install = function(Vue) {
  Vue.component(CascaderView.name, CascaderView);
};
CascaderView.version = version;

export { CascaderView as default };
